<?php

namespace hacklabBlocks;

/**
 * Server-side rendering of the `hacklab-blocks/post-meta` block.
 *
 * @package WordPress
 */

/**
 * Renders the `hacklab-blocks/post-meta` block on the server.
 *
 * @param array    $attributes Block attributes.
 * @param string   $content    Block default content.
 * @param WP_Block $block      Block instance.
 * @return string Returns the filtered post terms for the current post wrapped inside "a" tags.
 */

function co_authors_meta_callback($attributes, $content, $block)
{
	if (!isset($block->context['postId'])) {
		return '';
	}

	if( !class_exists( 'CoAuthors_Plus' ) ){
		return '';
	}



	$post_id = $block->context['postId'];
	$coauthors = get_coauthors($post_id);
	$prefix = isset( $attributes['prefix'] ) ? $attributes['prefix'] : '';
	$html = '';

	$html .= '<span class="co-authors-meta-block">';

	if($prefix){
		$html .= '<span class="prefix">';
		$html .= esc_html($prefix);
		$html .= '</span>';
	}

    foreach($coauthors as $coauthor){ 
		$html .= $coauthor->display_name;
		$html .= ' ';
	}
	$html .= '</span>';

	return $html;
}
