/**
 * External dependencies
 */
import classnames from 'classnames';
import { unescape } from 'lodash';
import ServerSideRender from '@wordpress/server-side-render';

/**
 * WordPress dependencies
 */
import {
	InspectorControls,
	BlockControls,
	useBlockProps,
} from '@wordpress/block-editor';
import {
	TextControl,
	Panel,
	PanelBody,
	FormTokenField

} from '@wordpress/components';
import { __ } from '@wordpress/i18n';
/**
 * Internal dependencies
 */

export default function Edit(props) {
	const attributes = props.attributes;
	const context = props.context;
	const setAttributes = props.setAttributes;
	const { prefix } = attributes;
	const { postId, postType } = context;
	
	const hasPost = postId && postType;
	const blockProps = useBlockProps({
		className: classnames({
			
		}),
	});
	return (
		<div { ...useBlockProps() }>

			<InspectorControls key="setting">
				<Panel>
					<PanelBody title={__('Configurações do bloco')}>

						<TextControl
							autoComplete="off"
							label={__('Prefixo')}
							value={prefix || ''}
							onChange={(nextValue) => {
								setAttributes({ prefix: nextValue });
							}}
							help={__('Adicione um prefixo antes dos autores.')}
						/>

					</PanelBody>
				</Panel>
			</InspectorControls>

			<div className="configBlock">
				<header><p>CoAuthorsMeta</p></header>
			</div>
		 </div>
	);
}