<?php
namespace hacklabBlocks;
// filtros:
// fetch-tainacan-api-data
// fetch-tainacan-api-classColumn
// fetch-tainacan-api-before-link-embed_post
// fetch-tainacan-api-before-image-embed_post
// fetch-tainacan-api-after-image-embed_post
// fetch-tainacan-api-before-category-embed_post
// fetch-tainacan-api-after-category-embed_post
// fetch-tainacan-api-before-author-embed_post
// fetch-tainacan-api-before-excerpt-embed_post
// fetch-tainacan-api-classSlider
function get_items_from_cache( $block_id ) {
    $block_id = str_replace( '-', '', $block_id );
    return get_transient( "fetch_tainacan_api_{$block_id}" );
}
function update_items_from_cache( $block_id, $value ) {
    $block_id = str_replace( '-', '', $block_id );

    return set_transient( "fetch_tainacan_api_{$block_id}", $value, MONTH_IN_SECONDS );
}

function fetch_items_api_callback( $attributes = [] ) {

	if ( isset( $attributes['jsonURL'] ) && ! empty( $attributes['jsonURL'] ) ) {
		$_json_url = esc_url_raw( $attributes['jsonURL'] );
	} elseif ( defined( 'TAINACAN_VERSION' ) ) {
		$_json_url = get_rest_url( null, 'tainacan/v2/items' );
	} else {
		if ( defined( 'REST_REQUEST' ) && REST_REQUEST ) {
			return 'Adicione a URL da API Tainacan nas configurações do bloco.';
		};
		return '';
	}

    $_json_url = add_query_arg( [
        'perpage' => $attributes['queryNumItems'],
        '_embed'  => true,
	], $_json_url);

    $json = file_get_contents( $_json_url );
    $data = json_decode( $json, TRUE );

    if ( $data && isset( $data['items'] ) ){
        $data = $data['items'];
    }

    if ( ! $data ) {
        $data = get_items_from_cache( $attributes[ 'clientId' ] );
        if ( ! $data ) {
            if ( current_user_can('editor') || current_user_can('administrator') ) {
                return 'Error on loading posts';
            }
            return '';
        }
    }

    update_items_from_cache( $attributes[ 'clientId' ], $data );

    $embed_post ='';

    if ( $attributes['isSlide'] == true ) {
        $embed_post .= '<section id="" class="wp-block-fetch-tainacan-api post-card wp-block-columns featured-slider"><div class="itens-wrapper">';
    } else {
        $embed_post .= '<section id="" class="wp-block-fetch-tainacan-api post-card wp-block-columns" data-columns="'.$attributes['selectColumns'].'" >';
    }

    $data = apply_filters( 'fetch-tainacan-api-data', $data );

    foreach( $data as $index => $_post ) {
        $terms = $_post['terms'];
        $terms_str = '';
        $exclude = [];
        $exclude = apply_filters('fetch-tainacan-api-exclude-taxonomy',$exclude);

        if ( is_array( $terms ) ){
            foreach( $terms as $term ) {
                if ( isset( $term[0] ) ) {
                    if(!in_array($term[0]['taxonomy'], $exclude)){
                        if( isset( $term[0]['link'] ) && isset( $term[0]['name'] ) ) {
                            $terms_str.='<a target="_blank" href="'.$term[0]['link'].'">'.$term[0]['name'].'</a> ';
                        }
                    }
                }
            }
        }

        //adicionar opções do atributo para tamanhos de imagens e adicionar AQUI o retorno da imagem para o tamanho certo.
        //Exemplo $_posts['_embedded']['wp:featuredmedia']['media_details]['sizes']['thumbnail']

        $get_base_api = strpos( $attributes['jsonURL'], '/wp-json' );
        $get_base_api = substr( $attributes['jsonURL'], 0, $get_base_api ).'/wp-json/wp/v2/';
        $get_image_content = file_get_contents( $get_base_api . 'media/' . $_post['_thumbnail_id'] );
        $data_image = json_decode( $get_image_content, TRUE );

        if ( ! empty( $attributes[ 'imageSize' ] ) && isset( $data_image['media_details']['sizes'][$attributes[ 'imageSize' ]] ) ) {
            $image_featured = $data_image['media_details']['sizes'][$attributes[ 'imageSize' ]]['source_url'];
        } else {
            $image_featured = isset( $data_image['media_details']['sizes']['tainacan-medium']['source_url'] ) ? $data_image['media_details']['sizes']['tainacan-medium']['source_url'] : false;
        }

        // QUANTIDADE DE COLUNAS / LAYOUT DO BLOCO
        //-> full-column: para card com tamanho 1 coluna (fullsize)
        //-> half-column: para card com tamanho 2 colunas
        //-> thirt-column: para card com tamanho 3 colunas
        //-> half-column + img-left : card meia coluna porém com imagem alinhada a esquerda do texto

        if ( $attributes['isSlide'] == true ) {
            $classColumn = '';
        } else {
            $classColumn = 'column ';
        }

        if(isset($attributes['selectColumns']) && $attributes['selectColumns'] == 2){
            $classColumn .= ' half-column';
        }
        elseif(isset($attributes['selectColumns']) && $attributes['selectColumns'] == 3){
            $classColumn .= ' thirt-column';
        }
        else{
            $classColumn .= ' full-column';
        }

        // filtro para adicionar classes nas colunas
        $classColumn = apply_filters('fetch-tainacan-api-classColumn',$classColumn);

        // filtro para adicionar algo antes do link dos posts
        $embed_post = apply_filters('fetch-tainacan-api-before-link-embed_post',$embed_post, $attributes,$_post);

        // $embed_post .= '<div class="'.$classColumn.' slide-item-wrapper" data-id="post-'.$_post['id'].'">';

        if($attributes['isSlide'] == true){
            $embed_post .= '<div class="slide-item-wrapper half-column img-left">';
        }else{
            $embed_post .= '<div class="'.$classColumn. '' .$_post['title']. '" data-id="post-'.$_post['id'].'">';
        }


        // filtro para adicionar algo antes da imagem
        $embed_post = apply_filters('fetch-tainacan-api-before-image-embed_post',$embed_post, $attributes,$_post);


        //EXIBE A IMAGEM DESTACADA
        if ( $image_featured && $attributes['showImage'] == true ) {
            if ( ! $attributes[ 'showImageOnFirstOnly'] || $attributes[ 'showImageOnFirstOnly'] && $index === 0 ) {
                $embed_post .= '<div class="post-image aspect-radio" style="background-image:url('.$image_featured.')"><a target="_blank" href="'. $_post['url'].'" target="_self" class="post-link"></a></div>';
            }
            // //MUDANÇA $embed_post .= '<a href="'. $_post['link'].'" target="_self" class="post-link"><img src="'.$image_featured.'" /></a>';
        }

        // filtro para adicionar algo depois da imagem
        $embed_post = apply_filters('fetch-tainacan-api-after-image-embed_post',$embed_post, $attributes,$_post);


        // //MUDANÇA: $embed_post .= '<div class="post-info">';

        // filtro para adicionar algo antes da categoria
        $embed_post = apply_filters('fetch-tainacan-api-before-category-embed_post',$embed_post, $attributes,$_post);

        //EXIBE A CATEGORIA
        if($attributes['showCategory'] == true){
            $embed_post .= '<p class="post-category">'.$terms_str.'</p>';
        }

        $embed_post .= '<a target="_blank" href="'. $_post['url'].'" target="_self" class="post-link">';

        // filtro para adicionar algo depois da categoria
        $embed_post = apply_filters('fetch-tainacan-api-after-category-embed_post',$embed_post, $attributes,$_post);


        $embed_post .= '<h2 class="post-title">'.$_post['title'].'</h2>';

        // filtro para adicionar algo antes do autor da categoria
        $embed_post = apply_filters('fetch-tainacan-api-before-author-embed_post',$embed_post, $attributes,$_post);

        //EXIBE O AUTOR DO POST
        if($attributes['showAuthor'] == true){
            // usuario do wordpress
            $author = get_post_field( 'post_author', $_post['author_name'] );
            $embed_post .= '<p class="post-authors">'.$author.'</p>';
        }
        if($attributes['showDate'] == true){
            $date =  $_post[ 'creation_date'];
            // $date = date( get_option('date_format'), strtotime( $_post[ 'creation_date'] ) );

            $date = apply_filters('fetch-tainacan-api-date-format', $date, $attributes,$_post );

            if ( $attributes['showIdentificationOnDate'] ) {
                $embed_post .= "
                    <div class='post-date'>
                        <time>{$date}</time>
                        <span class='site-title'>{$attributes[ 'titleBlock']}</span>
                    </div>
                ";
            } else {
                $embed_post .= "
                    <div class='post-date'>
                        <time>{$date}</time>
                    </div>
                ";
            }

        }

        // filtro para adicionar algo antes do resumo
        $embed_post = apply_filters('fetch-tainacan-api-before-excerpt-embed_post',$embed_post, $attributes,$_post);

        //EXIBE O RESUMO
        if($attributes['showExcerpt'] == true){
            $embed_post .= '<p class="post-excerpt">';
            $embed_post .= strip_tags( $_post['description'] );
            $embed_post .='</p>';
        }

        // //MUDANÇA:  $embed_post .= '</div><!--class="post-info"--></a></div><!--class="'.$classColumn.'" -->';
        $embed_post .= '</a></div>';

    };

    if ( $attributes['isSlide'] == true ) {
        $embed_post .= '</div></section>';
    } else {
        $embed_post .= '</section>';
    }

    return $embed_post;

}
