<?php
namespace hacklabBlocks;
/**
 * filter_by_taxonomy_callback
 */
$GLOBALS[ 'filter_by_taxonomy_attrs' ] = array();
$GLOBALS[ 'filter_by_taxonomy_already_filter_query' ] = false;

function filter_by_taxonomy_callback( $attributes, $content, $block ) {
    $block_id = $attributes[ 'blockId' ];

    $block_id = str_replace( '-', '', $block_id );

    $option_name = "filter_by_taxonomy_{$block_id}";

    if( ! wp_is_json_request() ) {
        update_option( $option_name, $attributes, false );
    }

    $tax_obj = get_taxonomy( $attributes[ 'taxonomy' ] );

    if( ! $tax_obj ) {
        return "<p>Error: Taxonomy {$attributes[ 'taxonomy' ]} not found.</p>";
    }

    $terms = get_terms( 
        array( 'taxonomy' => $attributes[ 'taxonomy' ] )
    );


    $terms_html = "";
    
    if($attributes['selectModel'] == true){
        if( ! isset( $_GET[ 'hl_term'] ) || empty( $_GET[ 'hl_term'] ) ) {
            $terms_html .= "<option value='' selected>Todos(as)</option>";
        } else {
            $terms_html .= "<option value=''>Todos</option>";
        }
    
        foreach( $terms as $term ) {
            if( isset( $_GET[ 'hl_term'] ) && $term->slug == $_GET[ 'hl_term'] ) {
                $terms_html .= "<option value='{$term->slug}' selected>{$term->name}</option>";
            } else {
                $terms_html .= "<option value='{$term->slug}'>{$term->name}</option>";
            }
        }
    
        $html = "
            <form class='wp-block-hacklab-filter-by-taxonomy'>
                <input type='hidden' name='hl_blockid' value='{$block_id}' />
                <label for='hl_term'>{$tax_obj->label}</label>
    
                <select name='hl_term' onchange='this.form.submit()'>
                    {$terms_html}
                </select>
            </form>
        ";        
    }else{
        // if( ! isset( $_GET[ 'hl_term'] ) || empty( $_GET[ 'hl_term'] ) ) {
        //     $terms_html .= "<li data-taxonomy='{$term->slug}' class='active'>Todos(as)</li>";
        // } else {
        //     $terms_html .= "<li data-taxonomy='{$term->slug}'>Todos</li>";
        // }
        

        foreach( $terms as $term ) {
            $term_link = get_term_link( $term );

            if( isset( $_GET[ 'hl_term'] ) && $term->slug == $_GET[ 'hl_term'] ) {
                $terms_html .= "<li data-taxonomy='{$term->slug}' class='active'>{$term->name}</option>";
            } else {
                $terms_html .= "<li data-taxonomy='{$term->slug}'><a href='{$term_link}'>{$term->name}</a></li>";
            }
        }

        $html = "
                <ul>
                {$terms_html}
                </ul>
        ";
    }


    $GLOBALS[ 'filter_by_taxonomy_attrs' ] [ $block_id ] = $attributes;
    return $html;

}
function filter_by_taxonomy_pre_get_posts( $query ) {
    if( ! isset( $_GET[ 'hl_blockid'] ) ) {
        return;
    }
    $block_id = str_replace( '-', '', sanitize_text_field( $_GET[ 'hl_blockid'] ) );
    $option_name = "filter_by_taxonomy_{$block_id}";

    $filter_by_taxonomy_attrs = get_option( $option_name, false );
    
    if ( ! $filter_by_taxonomy_attrs ) {
        return;
    }
    if( ! isset( $_GET[ 'hl_term'] ) || empty( $_GET[ 'hl_term'] )  ) {
        return;
    }
    $attributes = $filter_by_taxonomy_attrs;

    if( $attributes[ 'postType' ] != $query->get( 'post_type') ) {
        return;
    }

    $term = get_term_by( 'slug', $_GET[ 'hl_term'], $attributes[ 'taxonomy' ], OBJECT, 'raw' );



    $tax_query = $query->get( 'tax_query' );
    if( empty( $tax_query ) ) {
        $query->set( 'tax_query',
            array(
                array(
                    'taxonomy' => $attributes[ 'taxonomy' ],
                    'field'    => 'slug',
                    'terms'    => esc_textarea( $_GET[ 'hl_term'] ),
                ),
            ) 
        );    
    } else {
        $tax_query[] = array(
            'taxonomy' => $attributes[ 'taxonomy' ],
            'field'    => 'slug',
            'terms'    => esc_textarea( $_GET[ 'hl_term'] ),
        );
        $query->set( 'tax_query', $tax_query );    
    }


    return $query;
}
add_action( 'pre_get_posts', 'hacklabBlocks\\filter_by_taxonomy_pre_get_posts', 999 );

function filter_by_taxonomy_has_term_in_query( $tax_query, $term_id, $attributes ) {
    foreach( $tax_query as $tax ) {
        if( $attributes[ 'taxonomy' ] == $tax[ 'taxonomy'] ) {
            if( in_array( $term_id, $tax[ 'terms'] ) ) {
                return true;
            }
        }
    }
    return false;
}
