<?php
namespace hacklabBlocks;
// filtros:
// hacklab-fetch-posts-api-data
// hacklab-fetch-posts-api-classColumn
// hacklab-fetch-posts-api-before-link-embed_post
// hacklab-fetch-posts-api-before-image-embed_post
// hacklab-fetch-posts-api-after-image-embed_post
// hacklab-fetch-posts-api-before-category-embed_post
// hacklab-fetch-posts-api-after-category-embed_post
// hacklab-fetch-posts-api-before-author-embed_post
// hacklab-fetch-posts-api-before-excerpt-embed_post
// hacklab-fetch-posts-api-each_mounted_post
// hacklab-fetch-posts-api-classSlider
function get_posts_from_cache( $block_id ) {
    $block_id = str_replace( '-', '', $block_id );
    return get_transient( "hacklab_fetch_posts_api_{$block_id}" );
}
function update_posts_from_cache( $block_id, $value ) {
    $block_id = str_replace( '-', '', $block_id );

    return set_transient( "hacklab_fetch_posts_api_{$block_id}", $value, MONTH_IN_SECONDS );
}

function fetch_posts_api_callback( $attributes = [] ) {

	$base_url = extract_base_url( $attributes['jsonURL'] );

    $_json_url = $attributes['jsonURL'] ? $attributes['jsonURL'] : get_rest_url( null, '/wp/v2/posts' );
    $_json_url = add_query_arg( array(
        'per_page' => $attributes['queryNumItems'],
        '_embed'   => true,
    ),$_json_url);
    $json = file_get_contents($_json_url);
    $data = json_decode($json, TRUE);

	// Fix array when use ID to call specific post
	if ( is_array( $data ) && ! empty( $data ) && ! array_key_exists( '0', $data ) ) {
		$data = [0 => $data];
	}

	if ( ! $data ) {
		$data = get_posts_from_cache( $attributes['clientId'] );

		if ( ! $data || is_empty_recursive( $data ) ) {
			if ( current_user_can( 'editor' ) || current_user_can( 'administrator' ) ) {
				return '<h2 class="block-error">Error on loading posts</h2>';
			}
			return '';
		}
	}

    update_posts_from_cache( $attributes[ 'clientId' ], $data );

    $embed_post ='';

    if ( $attributes['isSlide'] == true ) {
        $ppp = ( isset( $attributes['ppp'] ) && ! empty( $attributes['ppp'] ) ) ? intval( $attributes['ppp'] ) : 1;
        $show_dots = ( isset( $attributes['showDots'] ) && ! empty( $attributes['showDots'] ) ) ? boolval( $attributes['showDots'] ) : false;
        $embed_post .= '<section id="" class="wp-block-fetch-posts post-slider featured-slider"><div class="itens-wrapper" data-ppp="' . $ppp . '" data-dots="' . $show_dots . '">';
    } else {
        $select_columns = ( isset( $attributes['selectColumns'] ) && ! empty( $attributes['selectColumns'] ) ) ? intval( $attributes['selectColumns'] ) : 1; 
        $embed_post .= '<section id="" class="wp-block-fetch-posts post-card wp-block-columns" data-columns="' . $select_columns . '" >';
    }

    $data = apply_filters( 'hacklab-fetch-posts-api-data', $data );

    foreach($data as $index => $_post ){
        // $terms = $_post['_embedded']['wp:term'];
        $mount_post = '';
        $terms_str = '';
        $exclude = [];
        $exclude = apply_filters('hacklab-fetch-posts-api-exclude-taxonomy',$exclude);
        // foreach($terms as $term){

        //     if ( isset( $term[0] ) ) {
        //         if(!in_array($term[0]['taxonomy'], $exclude)){
        //             if( isset( $term[0]['link'] ) && isset( $term[0]['name'] ) ) {
        //                 $terms_str.='<a target="_blank" href="'.$term[0]['link'].'">'.$term[0]['name'].'</a> ';
        //             }
        //         }
        //     }

        // }

        //adicionar opções do atributo para tamanhos de imagens e adicionar AQUI o retorno da imagem para o tamanho certo.
        //Exemplo $_posts['_embedded']['wp:featuredmedia']['media_details]['sizes']['thumbnail']
        $image_featured = isset($_post['_embedded']['wp:featuredmedia']) ? $_post['_embedded']['wp:featuredmedia'][0]['source_url'] : true;

        if( ! empty( $attributes[ 'imageSize' ] ) && isset( $_post['_embedded']['wp:featuredmedia'][0]['media_details']['sizes'][$attributes[ 'imageSize' ]] ) ) {
            $image_featured = $_post['_embedded']['wp:featuredmedia'][0]['media_details']['sizes'][$attributes[ 'imageSize' ]]['source_url'];
        }

        // $image_credit = isset($_post['_embedded']['wp:featuredmedia']) ? $_post['_embedded']['wp:featuredmedia'][0]['media_details']['image_meta']['credit'] : false;


        // QUANTIDADE DE COLUNAS / LAYOUT DO BLOCO
        //-> full-column: para card com tamanho 1 coluna (fullsize)
        //-> half-column: para card com tamanho 2 colunas
        //-> thirt-column: para card com tamanho 3 colunas
        //-> half-column + img-left : card meia coluna porém com imagem alinhada a esquerda do texto

        if($attributes['isSlide'] == true){
            $classColumn = '';

        }else{

            $classColumn = 'column ';
        }


        if(isset($attributes['selectColumns']) && $attributes['selectColumns'] == 2){
            $classColumn .= ' half-column';
        }
        elseif(isset($attributes['selectColumns']) && $attributes['selectColumns'] === 3){
            $classColumn .= ' thirt-column';
        }
        elseif(isset($attributes['selectColumns']) && $attributes['selectColumns'] === 4){
            $classColumn .= ' fourth-column';
        }
        else{
            $classColumn .= ' full-column';
        }


        // filtro para adicionar classes nas colunas
        $classColumn = apply_filters('hacklab-fetch-posts-api-classColumn',$classColumn);

        // filtro para adicionar algo antes do link dos posts
        $mount_post = apply_filters('hacklab-fetch-posts-api-before-link-embed_post',$mount_post, $attributes,$_post);

        // $mount_post .= '<div class="'.$classColumn.' slide-item-wrapper" data-id="post-'.$_post['id'].'">';

        if($attributes['isSlide'] == true){
            $mount_post .= '<div class="slide-item-wrapper half-column img-left">';
        }else{
            $mount_post .= '<div class="'.$classColumn.'" data-id="post-'.$_post['id'].'">';
        }


        // filtro para adicionar algo antes da imagem
        $mount_post = apply_filters('hacklab-fetch-posts-api-before-image-embed_post',$mount_post, $attributes,$_post);


        //EXIBE A IMAGEM DESTACADA
        if ( $image_featured && $attributes['showImage'] == true ) {
            if ( ! $attributes[ 'showImageOnFirstOnly'] || $attributes[ 'showImageOnFirstOnly'] && $index === 0 ) {
                $mount_post .= '<div class="post-image aspect-radio" style="background-image:url('.$image_featured.')"><a target="_blank" href="'. $_post['link'].'" target="_self" class="post-link"></a></div>';
            }
            // //MUDANÇA $mount_post .= '<a href="'. $_post['link'].'" target="_self" class="post-link"><img src="'.$image_featured.'" /></a>';
        }

        // filtro para adicionar algo depois da imagem
        $mount_post = apply_filters('hacklab-fetch-posts-api-after-image-embed_post',$mount_post, $attributes,$_post);


        // //MUDANÇA: $mount_post .= '<div class="post-info">';

        // filtro para adicionar algo antes da categoria
        $mount_post = apply_filters('hacklab-fetch-posts-api-before-category-embed_post',$mount_post, $attributes,$_post);

        //EXIBE A CATEGORIA
        if($attributes['showCategory'] == true){
            $mount_post .= '<p class="post-category">'.$terms_str.'</p>';
        }

		$terms = [];
		if ( isset( $attributes['showTaxonomies'] ) && ! empty( $attributes['showTaxonomies'] ) ) {

			foreach ( explode( ',', $attributes['showTaxonomies'] ) as $tax ) {
				$tax = sanitize_title( $tax );

				if ( isset( $_post['_embedded']['wp:term'] ) && ! empty( $_post['_embedded']['wp:term'] ) ) {
					foreach ( $_post['_embedded']['wp:term'] as $items ) {
						foreach ( $items as $item ) {
							if ( isset( $item['taxonomy'] ) && $item['taxonomy'] == $tax ) {
								$terms[] = $item;
							}
						}
					}
				}
			}
		}

		if ( $terms ) {
			$term_links = [];

			foreach ( $terms as $term ) {
				$term_links[] = '<a class="tax-' . esc_html( $term['taxonomy'] ) . '" href="' . esc_url( $term['link'] ) . '">' . esc_html( $term['name'] ) . '</a>';
			}

			$mount_post .= '<div class="taxonomy-terms">' . implode( '', $term_links ) . '</div>';
		}

		$mount_post .= '<a target="_blank" href="'. $_post['link'].'" target="_self" class="post-link">';

        // filtro para adicionar algo depois da categoria
        $mount_post = apply_filters('hacklab-fetch-posts-api-after-category-embed_post',$mount_post, $attributes,$_post);

        $mount_post .= '<h2 class="post-title">'.$_post['title']['rendered'].'</h2>';

        // filtro para adicionar algo antes do autor da categoria
        $mount_post = apply_filters('hacklab-fetch-posts-api-before-author-embed_post',$mount_post, $attributes,$_post);

		// EXIBE O AUTOR DO POST
		if( $attributes['showAuthor'] == true ) {
			$get_user_data = get_user_from_api( $base_url . "/wp-json/wp/v2/users", $_post['author'] );

			if ( $get_user_data && is_object( $get_user_data ) ) {
				$mount_post .= '<p class="post-authors">' . $get_user_data->name . '</p>';
			}
		}

        if($attributes['showDate'] == true){
            $date = date_i18n( get_option( 'date_format' ), strtotime( $_post[ 'date'] ) );
            $date = apply_filters('hacklab-fetch-posts-api-date-format', $date, $attributes,$_post );

            if ( $attributes['showIdentificationOnDate'] ) {
                $mount_post .= "
                    <div class='post-date'>
                        <time>{$date}</time>
                        <span class='site-title'>{$attributes[ 'titleBlock']}</span>
                    </div>
                ";
            } else {
                $mount_post .= "
                    <div class='post-date'>
                        <time>{$date}</time>
                    </div>
                ";
            }

        }

        // filtro para adicionar algo antes do resumo
        $mount_post = apply_filters('hacklab-fetch-posts-api-before-excerpt-embed_post',$mount_post, $attributes,$_post);

        //EXIBE O RESUMO
        if($attributes['showExcerpt'] == true){
            $mount_post .= '<p class="post-excerpt">';
            $mount_post .= strip_tags($_post['excerpt']['rendered']);
            $mount_post .='</p>';
        }

        // //MUDANÇA:  $mount_post .= '</div><!--class="post-info"--></a></div><!--class="'.$classColumn.'" -->';
        $mount_post .= '</a></div>';

		// Filtro para alterar o HTML de cada post
        $mount_post = apply_filters( 'hacklab-fetch-posts-api-each_mounted_post', $mount_post, $attributes, $_post );

        $embed_post .= $mount_post;

    };

    if($attributes['isSlide'] == true){
        $embed_post .= '</div></section>';

    }else{
        $embed_post .= '</section>';

    }

    return $embed_post;

}
