/**
 * External dependencies
 */
import classnames from 'classnames';
import { unescape } from 'lodash';
import ServerSideRender from '@wordpress/server-side-render';

/**
 * WordPress dependencies
 */
import {
	InspectorControls,
	BlockControls,
	useBlockProps,
} from '@wordpress/block-editor';
import {
	TextControl,
	Panel,
	PanelBody,
	FormTokenField

} from '@wordpress/components';
import { __ } from '@wordpress/i18n';
/**
 * Internal dependencies
 */

export default function Edit(props) {
	const attributes = props.attributes;
	const context = props.context;
	const setAttributes = props.setAttributes;
	const { separator, selectedMeta } = attributes;
	const { postId, postType } = context;
	
	const hasPost = postId && postType;
	const blockProps = useBlockProps({
		className: classnames({
			
		}),
	});
	return (
		<div { ...useBlockProps() }>

			<InspectorControls key="setting">
				<Panel>
					<PanelBody title={__('Configurações do bloco')}>

						<TextControl
							autoComplete="off"
							label={__('Separator')}
							value={separator || ''}
							onChange={(nextValue) => {
								setAttributes({ separator: nextValue });
							}}
							help={__('Enter character(s) used to separate terms.')}
						/>
						<FormTokenField
							value={selectedMeta || ''}
							
							onChange={(nextValue) => {
								setAttributes({ selectedMeta: nextValue });
							}}
						/>
					</PanelBody>
				</Panel>
			</InspectorControls>

			<div className="configBlock">
				<header><p>PostMeta</p></header>
			</div>
		 </div>
	);
}